%if 0%{?fedora}
%global with_python3 1
%global python3_pkgversion 3

## Make python?_shortver macros
%{!?python2_shortver: %global python2_shortver %(%{__python2} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%{!?python3_shortver: %global python3_shortver %(%{__python3} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%endif

%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%global with_python3 0
%global python2_version 2.6
%endif

%if 0%{?rhel} && 0%{?rhel} > 6
%global with_python3 1
%{!?python2_shortver: %global python2_shortver %(%{__python2} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%{!?python3_shortver: %global python3_shortver %(%{__python3} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%endif

%global   checkout ee9a4eeba7ebdb348aa16a81ea42aae2421554ef
%global   date     20161226

Name: autowrap
Summary: Generates Python Extension modules from [Cython] PXD files
Version: 0.9.2
Release: 1.%{date}git%(echo %{checkout} | cut -c-6)%{?dist}
License: BSD
URL: https://github.com/uweschmitt/autowrap
Source0: https://github.com/uweschmitt/autowrap/archive/%{checkout}.zip#/%{name}-%{checkout}.zip
BuildArch: noarch

BuildRequires: python2-devel, python-setuptools, python-nose, pytest, Cython
##Testing
BuildRequires: boost-devel
Requires: Cython

%description
This module uses the Cython "header" .pxd files to automatically generate
Cython input (.pyx) files. It does so by parsing the header files and possibly
annotations in the header files to generate correct Cython code.

%package -n python2-autowrap
Summary: Generates Python2 Extension modules from [Cython] PXD files
%{?python_provide:%python_provide python2-%{name}}
Requires: Cython
%description -n python2-autowrap
%{summary}.

%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-autowrap
Summary: Generates Python3 Extension modules from [Cython] PXD files
%{?python_provide:%python_provide python%{python3_pkgversion}-%{name}}
BuildRequires: python%{python3_pkgversion}-devel
BuildRequires: python%{python3_pkgversion}-setuptools
BuildRequires: python%{python3_pkgversion}-nose
BuildRequires: python%{python3_pkgversion}-pytest
BuildRequires: python%{python3_pkgversion}-Cython
Requires: python%{python3_pkgversion}-Cython

%description -n python%{python3_pkgversion}-autowrap
%{summary}.
%endif # with_python3

%prep
%setup -qc

mv autowrap-%{checkout} python2
pushd python2
##Remove bundled files
rm -rf autowrap/data_files/boost
popd

%if 0%{?with_python3}
cp -a python2 python3
%endif # with_python3

%build
pushd python2
%py2_build
popd

%if 0%{?with_python3}
pushd python3
%py3_build
popd
%endif # with_python3

%install

# Must do the python3 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python2 version
# to be the default for now).
%if 0%{?with_python3}
pushd python3
%py3_install
mv $RPM_BUILD_ROOT%{_bindir}/autowrap $RPM_BUILD_ROOT%{_bindir}/python%{python3_version}-autowrap

mkdir exe && pushd exe
for i in autowrap-3 autowrap-%{?python3_shortver}; do
  touch -r $RPM_BUILD_ROOT%{_bindir}/python%{python3_version}-autowrap $i
  install -p $i $RPM_BUILD_ROOT%{_bindir}
  ln -sf %{_bindir}/python%{python3_version}-autowrap $RPM_BUILD_ROOT%{_bindir}/$i
done
popd
popd
%endif

pushd python2
%py2_install

mv $RPM_BUILD_ROOT%{_bindir}/autowrap $RPM_BUILD_ROOT%{_bindir}/python%{python2_version}-autowrap

mkdir exe && pushd exe
for i in autowrap autowrap-2 autowrap-%{?python2_shortver}; do
  touch -r $RPM_BUILD_ROOT%{_bindir}/python%{python2_version}-autowrap $i
  install -p $i $RPM_BUILD_ROOT%{_bindir}
  ln -sf %{_bindir}/python%{python2_version}-autowrap $RPM_BUILD_ROOT%{_bindir}/$i
done
popd

%check
%if 0%{?with_python3}
pushd python3
export CPPFLAGS="-I%{_includedir}/boost"
export CXXFLAGS="-I%{_includedir}/boost"
py.test-%{?python3_shortver} -v tests
popd
%endif # with_python3

pushd python2
export CPPFLAGS="-I%{_includedir}/boost"
export CXXFLAGS="-I%{_includedir}/boost"
py.test-%{?python2_shortver} -v tests
popd

%files -n python2-autowrap
%{!?_licensedir:%global license %doc}
%doc python2/README.md python2/CONCEPT
%license python2/LICENSE
%{_bindir}/autowrap
%{_bindir}/autowrap-2
%{_bindir}/autowrap-%{python2_version}
%{_bindir}/python%{python2_version}-autowrap
%{python2_sitelib}/autowrap/
%exclude %{python2_sitelib}/tests
%{python2_sitelib}/*.egg-info

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-autowrap
%{!?_licensedir:%global license %doc}
%doc python3/README.md python3/CONCEPT
%license python3/LICENSE
%{_bindir}/autowrap-3
%{_bindir}/autowrap-%{python3_version}
%{_bindir}/python%{python3_version}-autowrap
%{python3_sitelib}/autowrap/
%exclude %{python3_sitelib}/tests
%{python3_sitelib}/*.egg-info
%endif

%changelog
* Mon Dec 26 2016 Antonio Trande <sagitterATfedoraproject.org> - 0.9.2-1.20161226gitee9a4e
- Update to 0.9.2

* Sat Dec 24 2016 Antonio Trande <sagitterATfedoraproject.org> - 0.8.0-3.20130921git3f4808
- Exclude tests.test_main.test* (upstream bug #56)

* Mon Dec 19 2016 Miro Hrončok <mhroncok@redhat.com> - 0.8.0-2.20160921git3f4808
- Rebuild for Python 3.6

* Tue Nov 08 2016 Antonio Trande <sagitterATfedoraproject.org> - 0.8.0-1.20130921git3f4808
- Update to 0.8.0

* Wed Aug 17 2016 Antonio Trande <sagitterATfedoraproject.org> - 0.7.2-4.20130710git03c5d3
- Rebuild for Python-3.5.2

* Sat Aug 06 2016 Antonio Trande <sagitterATfedoraproject.org> - 0.7.2-3.20130710git03c5d3
- Build Python3.4 version on epel7

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.7.2-2.20160710git03c5d3
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Mon Jul 11 2016 Antonio Trande <sagitterATfedoraproject.org> - 0.7.2-1.20130710git03c5d3
- Update to 0.7.2 (commit #03c5d3)

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.1-5.20151201gitbd06ff
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jan 29 2016 Antonio Trande <sagitterATfedoraproject.org> - 0.7.1-4.20151201gitbd06ff
- Renamed Python2 package

* Thu Jan 14 2016 Jonathan Wakely <jwakely@redhat.com> - 0.7.1-3.20151201gitbd06ff
- Rebuilt for Boost 1.60

* Thu Dec 10 2015 Antonio Trande <sagitterATfedoraproject.org> - 0.7.1-2.20151201gitbd06ff
- SPEC file adapted to recent guidelines for Python

* Thu Nov 26 2015 Antonio Trande <sagitterATfedoraproject.org> 0.7.1-1.20151201gitbd06ff
- Update to 0.7.1
- autowrap-? renamed as autowrap?

* Thu Nov 26 2015 Antonio Trande <sagitterATfedoraproject.org> 0.7.0-1.20151124gitd5e233
- Update to 0.7.0

* Thu Nov 12 2015 Kalev Lember <klember@redhat.com> - 0.6.1-11.20150209gitd0e9a5
- Rebuilt for https://fedoraproject.org/wiki/Changes/python3.5

* Tue Nov 10 2015 Antonio Trande <sagitterATfedoraproject.org> 0.6.1-10.20150209gitd0e9a5
- Rebuilt for Python3.5

* Tue Nov 10 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.1-9.20150209gitd0e9a5
- Rebuilt for https://fedoraproject.org/wiki/Changes/python3.5

* Sun Sep 27 2015 Antonio Trande <sagitterATfedoraproject.org> 0.6.1-8.20150209gitd0e9a5
- Avoid executable conflicts

* Thu Aug 27 2015 Jonathan Wakely <jwakely@redhat.com> - 0.6.1-7.20150209gitd0e9a5
- Rebuilt for Boost 1.59

* Wed Jul 29 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.1-6.20150209gitd0e9a5
- Rebuilt for https://fedoraproject.org/wiki/Changes/F23Boost159

* Wed Jul 22 2015 David Tardon <dtardon@redhat.com> - 0.6.1-5.20150209gitd0e9a5
- rebuild for Boost 1.58

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.6.1-4.20150209gitd0e9a5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Apr 16 2015 Antonio Trande <sagitterATfedoraproject.org> 0.6.1-3.20150209gitd0e9a5
- Adapted to EPEL6/7
- Built on F23

* Mon Feb 09 2015 Antonio Trande <sagitterATfedoraproject.org> 0.6.1-2.20150209gitd0e9a5
- Added missing pytest BR package
- Used %%license

* Mon Feb 09 2015 Antonio Trande <sagitterATfedoraproject.org> 0.6.1-1.20150209gitd0e9a5
- Update to 0.6.1

* Tue Jan 27 2015 Petr Machata <pmachata@redhat.com> - 0.5.0-5.20140603git1753b9
- Rebuild for boost 1.57.0

* Thu Jul 31 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-4.20140603git1753b9
- Package is now noarch

* Wed Jul 30 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-3.20140603git1753b9
- Fixed BuildRequires and Requires for python3 sub-package
- Removed TODO and CONCEPT files as user documentation

* Wed Jun 11 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-2.20140603git1753b9
- Fixed nosetests command according to new default python3 stack on Fedora 21+

* Thu Jun 05 2014 Antonio Trande <sagitterATfedoraproject.org> 0.5.0-1.20140603git1753b9
- Release 0.5.0

* Mon Jun 02 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-4.20140602gitebde9f
- Update to a new commit (fixed all license headers)

* Mon Jun 02 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-3.20140321git26e901
- Removed conditional macros for EPEL
- Fixed Source0

* Sun Jun 01 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-2.20140321git26e901
- Fixed License
- Fixed Requires package for python2/python3
- Excluded 'tests' directories by packaging
- Performing building operations to packaging independent Python3 module
- Disabled generation of the useless debuginfo package

* Fri May 30 2014 Antonio Trande <sagitterATfedoraproject.org> 0.4.0-1.20140321git26e901
- Initial build
- Fixed Version tag
